<template>
  <main>
    <div class="text-center w-96 mx-auto mt-20">
      <h1 class="mt-10 text-xl">Print Demo Browser</h1>
      <input type="text" class="mt-10 bg-white border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5" placeholder="Enter Serial Number" v-model="serialNumber" required>
      <button @click="print()" class="px-12 py-2 bg-blue-400 text-white rounded-lg mt-10">Print</button>
    </div>
  </main>
</template>

<script>
import {defineComponent} from 'vue'
import ZebraBrowserPrintWrapper from 'zebra-browser-print-wrapper';

export default defineComponent({
  data(){
    return {
      serialNumber: null
    }
  },
  mounted(){
    console.log(ZebraBrowserPrintWrapper)
  },
  methods: {
    async print(){
      try {
        // Create a new instance of the object
        const browserPrint =  new ZebraBrowserPrintWrapper();

        // Select default printer
        const defaultPrinter =  await browserPrint.getDefaultPrinter();

        // Set the printer
        browserPrint.setPrinter(defaultPrinter);

        // Check printer status
        const printerStatus = await browserPrint.checkPrinterStatus();

        // Check if the printer is ready
        if(printerStatus.isReadyToPrint) {

          // ZPL script to print a simple barcode
          const zpl = `^XA
                      ^BY2,2,100
                      ^FO20,20^BC^FD${this.serialNumber}^FS
                      ^XZ`;

          browserPrint.print(zpl);

        } else {
          console.log("Error/s", printerStatus.errors);
        }

      } catch (error) {
        throw new Error(error);
      }

    }
  }

})
</script>